Attribute VB_Name = "Module1"
Option Explicit

Public Const NO_ERROR = 0
Public Const ERROR_NONE = 0

Public Const HKEY_CLASSES_ROOT = &H80000000

Public Const KEY_ALL_ACCESS = &H3F
Public Const REG_DWORD = 4
Public Const REG_OPTION_NON_VOLATILE = 0
Public Const REG_SZ = 1

Declare Function RegCloseKey Lib "Coredll" ( _
  ByVal hkey As Long) _
  As Long

Declare Function RegCreateKeyEx Lib "Coredll" Alias "RegCreateKeyExW" ( _
  ByVal hkey As Long, _
  ByVal lpSubKey As String, _
  ByVal Reserved As Long, _
  ByVal lpClass As String, _
  ByVal dwOptions As Long, _
  ByVal samDesired As Long, _
  ByVal lpSecurityAttributes As Long, _
  phkResult As Long, _
  lpdwDisposition As Long) _
  As Long

Declare Function RegDeleteKey Lib "Coredll" Alias "RegDeleteKeyW" ( _
  ByVal hkey As Long, _
  ByVal lpSubKey As String) _
  As Long

Declare Function RegOpenKeyEx Lib "Coredll" Alias "RegOpenKeyExW" ( _
  ByVal hkey As Long, _
  ByVal lpSubKey As String, _
  ByVal ulOptions As Long, _
  ByVal samDesired As Long, _
  phkResult As Long) _
  As Long

Declare Function RegSetValueExLong Lib "Coredll" Alias "RegSetValueExW" ( _
  ByVal hkey As Long, _
  ByVal lpValueName As String, _
  ByVal Reserved As Long, _
  ByVal dwType As Long, _
  lpValue As Long, _
  ByVal cbData As Long) _
  As Long

Declare Function RegSetValueExString Lib "Coredll" Alias "RegSetValueExW" ( _
  ByVal hkey As Long, _
  ByVal lpValueName As String, _
  ByVal Reserved As Long, _
  ByVal dwType As Long, _
  ByVal lpValue As String, _
  ByVal cbData As Long) _
  As Long

Public Function CreateNewKey(lSection As Long, _
                             sNewKeyName As String)
       
    Dim hNewKey As Long
    Dim lRetVal As Long
    
    lRetVal = RegCreateKeyEx(lSection, sNewKeyName, CLng(0), _
              vbNullString, REG_OPTION_NON_VOLATILE, _
              KEY_ALL_ACCESS, _
              CLng(0), hNewKey, lRetVal)
    
    CreateNewKey = hNewKey
    
    RegCloseKey (hNewKey)

End Function

Public Function SetValueEx(ByVal hkey As Long, _
                           sValueName As String, _
                           lType As Long, vValue As Variant) As Long
       
    Dim lValue As Long
    Dim sValue As String
    
    Select Case lType
        Case REG_SZ
            sValue = vValue & Chr(0)
            SetValueEx = RegSetValueExString(hkey, sValueName, CLng(0), _
                                           lType, CStr(sValue), Len(sValue) * 2)
        Case REG_DWORD
            lValue = vValue
            SetValueEx = RegSetValueExLong(hkey, sValueName, CLng(0), _
                                           lType, CLng(lValue), 4)
    End Select
    
End Function


Public Sub SetKeyValue(lSection As Long, _
                       sKeyName As String, _
                       sValueName As String, _
                       vValueSetting As Variant, _
                       lValueType As Long)
   
    Dim lRetVal  As Long
    Dim hkey     As Long
       
    lRetVal = RegOpenKeyEx(lSection, sKeyName, _
                           0, _
                           KEY_ALL_ACCESS, hkey)
                              
    lRetVal = SetValueEx(hkey, sValueName, lValueType, vValueSetting)
    
    RegCloseKey (hkey)
End Sub


